diff -N -c -r -X exclude_files squid-1.0.beta5/src/ftp.c squid-1.0.beta5.henrik/src/ftp.c
*** squid-1.0.beta5/src/ftp.c	Fri Apr 26 00:11:29 1996
--- squid-1.0.beta5.henrik/src/ftp.c	Sun Apr 28 21:22:40 1996
***************
*** 18,28 ****
  
  typedef struct _Ftpdata {
      StoreEntry *entry;
!     char host[SQUIDHOSTNAMELEN + 1];
!     char request[MAX_URL];
      char user[MAX_URL];
      char password[MAX_URL];
-     int port;
      char *reply_hdr;
      int ftp_fd;
      char *icp_page_ptr;		/* Used to send proxy-http request: 
--- 18,26 ----
  
  typedef struct _Ftpdata {
      StoreEntry *entry;
!     request_t *request;
      char user[MAX_URL];
      char password[MAX_URL];
      char *reply_hdr;
      int ftp_fd;
      char *icp_page_ptr;		/* Used to send proxy-http request: 
***************
*** 35,40 ****
--- 33,53 ----
      int reply_hdr_state;
  } FtpData;
  
+ 
+ /* Local functions */
+ static int ftpStateFree _PARAMS((int fd, FtpData *ftpState));
+ static void ftpProcessReplyHeader _PARAMS((FtpData *data, char *buf, int size));
+ static void ftpServerClosed _PARAMS((int fd, void *nodata));
+ static void ftp_login_parser _PARAMS((char *login, FtpData *data));
+ 
+ /* Global functions not declared in ftp.h */
+ void ftpLifetimeExpire _PARAMS((int fd, FtpData *data));
+ int ftpReadReply _PARAMS((int fd, FtpData *data));
+ void ftpSendComplete _PARAMS((int fd, char *buf, int size, int errflag, FtpData *data));
+ void ftpSendRequest _PARAMS((int fd, FtpData *data));
+ void ftpConnInProgress _PARAMS((int fd, FtpData *data));
+ void ftpServerClose _PARAMS((void));
+ 
  static int ftpStateFree(fd, ftpState)
       int fd;
       FtpData *ftpState;
***************
*** 55,123 ****
      return 0;
  }
  
! int ftp_url_parser(url, data)
!      char *url;
!      FtpData *data;
  {
-     static char proto[MAX_URL];
-     static char hostbuf[MAX_URL];
-     char *s = NULL;
-     int t;
-     char *host = data->host;
-     char *request = data->request;
      char *user = data->user;
      char *password = data->password;
  
!     debug(9, 3, "ftp_url_parser: parsing '%s'\n", url);
! 
!     /* initialize everything */
!     proto[0] = hostbuf[0] = '\0';
! 
!     t = sscanf(url, "%[a-zA-Z]://%[^/]%s", proto, hostbuf, request);
!     if (t < 2)
! 	return -1;
!     if (strcasecmp(proto, "ftp") && strcasecmp(proto, "file"))
! 	return -1;
!     if (t == 2)			/* no request */
! 	strcpy(request, "/");
!     (void) url_convert_hex(request, 0);		/* convert %xx to char */
! 
!     /* hostbuf is of the format  userid:password@host:port  */
! 
!     /* separate into user-part and host-part */
!     if ((s = strchr(hostbuf, '@'))) {
! 	*s = '\0';
! 	strcpy(user, hostbuf);
! 	strcpy(hostbuf, s + 1);
!     }
!     /* separate into user and password */
!     if ((s = strchr(user, ':'))) {
! 	*s = '\0';
! 	strcpy(password, s + 1);
!     }
!     /* separate into host and port */
!     if ((s = strchr(hostbuf, ':'))) {
! 	*s = '\0';
! 	data->port = atoi(s + 1);
      }
!     strncpy(host, hostbuf, SQUIDHOSTNAMELEN);
!     if (*user == '\0')
  	strcpy(user, "anonymous");
-     if (*password == '\0')
  	strcpy(password, getFtpUser());
! 
!     /* we need to convert user and password for URL encodings */
!     (void) url_convert_hex(user, 0);
! 
!     (void) url_convert_hex(password, 0);
! 
!     debug(9, 5, "ftp_url_parser: proto = %s\n", proto);
!     debug(9, 5, "ftp_url_parser:  user = %s\n", data->user);
!     debug(9, 5, "ftp_url_parser:  pass = %s\n", data->password);
!     debug(9, 5, "ftp_url_parser:  host = %s\n", data->host);
!     debug(9, 5, "ftp_url_parser:  port = %d\n", data->port);
! 
!     return 0;
  }
  
  int ftpCachable(url)
--- 68,94 ----
      return 0;
  }
  
! static void ftp_login_parser(login, data)
!     char *login;
!     FtpData *data;
  {
      char *user = data->user;
      char *password = data->password;
+     char *s = NULL;
  
!     strcpy(user,login);
!     s=strchr(user,':');
!     if(s) {
!         *s=0;
! 	strcpy(password,s+1);
!     } else {
!     	strcpy(password,"");
      }
! 
!     if(!*user && !*password) {
  	strcpy(user, "anonymous");
  	strcpy(password, getFtpUser());
!     }
  }
  
  int ftpCachable(url)
***************
*** 451,462 ****
  
      debug(9, 5, "ftpSendRequest: FD %d\n", fd);
  
!     buflen = strlen(data->request) + 256;
      buf = (char *) get_free_8k_page();
      data->icp_page_ptr = buf;
      memset(buf, '\0', buflen);
  
!     path = data->request;
      l = strlen(path);
      if (path[l - 1] == '/')
  	mode = ftpASCII;
--- 422,433 ----
  
      debug(9, 5, "ftpSendRequest: FD %d\n", fd);
  
!     buflen = strlen(data->request->urlpath) + 256;
      buf = (char *) get_free_8k_page();
      data->icp_page_ptr = buf;
      memset(buf, '\0', buflen);
  
!     path = data->request->urlpath;
      l = strlen(path);
      if (path[l - 1] == '/')
  	mode = ftpASCII;
***************
*** 500,512 ****
  	sprintf(tbuf, "-n %d ", getNegativeTTL());
  	strcat(buf, tbuf);
      }
!     if (data->port) {
! 	sprintf(tbuf, "-P %d ", data->port);
  	strcat(buf, tbuf);
      }
      strcat(buf, "-h ");		/* httpify */
      strcat(buf, "- ");		/* stdout */
!     strcat(buf, data->host);
      strcat(buf, space);
      strcat(buf, path);
      strcat(buf, space);
--- 471,483 ----
  	sprintf(tbuf, "-n %d ", getNegativeTTL());
  	strcat(buf, tbuf);
      }
!     if (data->request->port) {
! 	sprintf(tbuf, "-P %d ", data->request->port);
  	strcat(buf, tbuf);
      }
      strcat(buf, "-h ");		/* httpify */
      strcat(buf, "- ");		/* stdout */
!     strcat(buf, data->request->host);
      strcat(buf, space);
      strcat(buf, path);
      strcat(buf, space);
***************
*** 559,567 ****
  }
  
  
! int ftpStart(unusedfd, url, entry)
       int unusedfd;
       char *url;
       StoreEntry *entry;
  {
      FtpData *data = NULL;
--- 530,539 ----
  }
  
  
! int ftpStart(unusedfd, url, request, entry)
       int unusedfd;
       char *url;
+      request_t *request;
       StoreEntry *entry;
  {
      FtpData *data = NULL;
***************
*** 571,585 ****
  
      data = (FtpData *) xcalloc(1, sizeof(FtpData));
      data->entry = entry;
  
!     /* Parse url. */
!     if (ftp_url_parser(url, data)) {
! 	squid_error_entry(entry, ERR_INVALID_URL, NULL);
! 	safe_free(data);
! 	return COMM_ERROR;
!     }
!     debug(9, 5, "FtpStart: FD %d, host=%s, request=%s, user=%s, passwd=%s\n",
! 	unusedfd, data->host, data->request, data->user, data->password);
  
      data->ftp_fd = comm_open(COMM_NONBLOCKING, 0, 0, url);
      if (data->ftp_fd == COMM_ERROR) {
--- 543,556 ----
  
      data = (FtpData *) xcalloc(1, sizeof(FtpData));
      data->entry = entry;
+     data->request = request;
  
!     /* Parse login info. */
!     ftp_login_parser(request->login, data);
! 
!     debug(9, 5, "FtpStart: FD %d, host=%s, path=%s, user=%s, passwd=%s\n",
! 	unusedfd, data->request->host, data->request->urlpath,
! 	data->user, data->password);
  
      data->ftp_fd = comm_open(COMM_NONBLOCKING, 0, 0, url);
      if (data->ftp_fd == COMM_ERROR) {
***************
*** 592,598 ****
      /* register close handler */
      comm_set_select_handler(data->ftp_fd,
  	COMM_SELECT_CLOSE,
! 	ftpStateFree,
  	(void *) data);
  
      /* Now connect ... */
--- 563,569 ----
      /* register close handler */
      comm_set_select_handler(data->ftp_fd,
  	COMM_SELECT_CLOSE,
! 	(PF)ftpStateFree,
  	(void *) data);
  
      /* Now connect ... */
diff -N -c -r -X exclude_files squid-1.0.beta5/src/ftp.h squid-1.0.beta5.henrik/src/ftp.h
*** squid-1.0.beta5/src/ftp.h	Thu Apr  4 03:30:43 1996
--- squid-1.0.beta5.henrik/src/ftp.h	Sun Apr 28 20:33:24 1996
***************
*** 1,6 ****
  
  /* $Id: squid-1.0.beta5.url_parse_ftp.patch,v 1.1 2000/08/13 23:15:50 hno Exp $ */
  
! extern int ftpStart _PARAMS((int unusedfd, char *url, StoreEntry * entry));
  extern int ftpInitialize _PARAMS((void));
  extern int ftpCachable _PARAMS((char *));
--- 1,6 ----
  
  /* $Id: squid-1.0.beta5.url_parse_ftp.patch,v 1.1 2000/08/13 23:15:50 hno Exp $ */
  
! extern int ftpStart _PARAMS((int unusedfd, char *url, request_t *req, StoreEntry * entry));
  extern int ftpInitialize _PARAMS((void));
  extern int ftpCachable _PARAMS((char *));
diff -N -c -r -X exclude_files squid-1.0.beta5/src/proto.c squid-1.0.beta5.henrik/src/proto.c
*** squid-1.0.beta5/src/proto.c	Wed Apr 24 07:52:52 1996
--- squid-1.0.beta5.henrik/src/proto.c	Sun Apr 28 20:32:43 1996
***************
*** 411,417 ****
      } else if (request->protocol == PROTO_GOPHER) {
  	return gopherStart(fd, url, entry);
      } else if (request->protocol == PROTO_FTP) {
! 	return ftpStart(fd, url, entry);
      } else if (request->protocol == PROTO_WAIS) {
  	return waisStart(fd, url, entry->method, request_hdr, entry);
      } else if (entry->method == METHOD_CONNECT) {
--- 411,417 ----
      } else if (request->protocol == PROTO_GOPHER) {
  	return gopherStart(fd, url, entry);
      } else if (request->protocol == PROTO_FTP) {
! 	return ftpStart(fd, url, request, entry);
      } else if (request->protocol == PROTO_WAIS) {
  	return waisStart(fd, url, entry->method, request_hdr, entry);
      } else if (entry->method == METHOD_CONNECT) {
diff -N -c -r -X exclude_files squid-1.0.beta5/src/url.c squid-1.0.beta5.henrik/src/url.c
*** squid-1.0.beta5/src/url.c	Wed Apr 24 17:16:55 1996
--- squid-1.0.beta5.henrik/src/url.c	Sun Apr 28 19:43:54 1996
***************
*** 161,173 ****
       char *url;
  {
      static char proto[MAX_URL + 1];
      static char host[MAX_URL + 1];
      static char urlpath[MAX_URL + 1];
      request_t *request = NULL;
      char *t = NULL;
      int port;
      protocol_t protocol = PROTO_NONE;
!     proto[0] = host[0] = urlpath[0] = '\0';
  
      if (method == METHOD_CONNECT) {
  	port = CONNECT_PORT;
--- 161,174 ----
       char *url;
  {
      static char proto[MAX_URL + 1];
+     static char login[MAX_URL + 1];
      static char host[MAX_URL + 1];
      static char urlpath[MAX_URL + 1];
      request_t *request = NULL;
      char *t = NULL;
      int port;
      protocol_t protocol = PROTO_NONE;
!     proto[0] = host[0] = urlpath[0] = login[0] = '\0';
  
      if (method == METHOD_CONNECT) {
  	port = CONNECT_PORT;
***************
*** 180,185 ****
--- 181,193 ----
  	    return NULL;
  	protocol = urlParseProtocol(proto);
  	port = urlDefaultPort(protocol);
+ 	/* Is there any login informaiton? */
+ 	if ((t = strrchr(host, '@'))) {
+ 	    strcpy(login,host);
+ 	    t=strrchr(login,'@');
+ 	    *t=0;
+ 	    strcpy(host,t+1);
+ 	}
  	if ((t = strrchr(host, ':')) && *(t + 1) != '\0') {
  	    *t = '\0';
  	    port = atoi(t + 1);
***************
*** 195,200 ****
--- 203,209 ----
      request->method = method;
      request->protocol = protocol;
      strncpy(request->host, host, SQUIDHOSTNAMELEN);
+     strncpy(request->login, login, MAX_URL);
      request->port = port;
      strncpy(request->urlpath, urlpath, MAX_URL);
      return request;
***************
*** 216,223 ****
  	portbuf[0] = '\0';
  	if (request->port != urlDefaultPort(request->protocol))
  	    sprintf(portbuf, ":%d", request->port);
! 	sprintf(buf, "%s://%s%s%s",
  	    ProtocolStr[request->protocol],
  	    request->host,
  	    portbuf,
  	    request->urlpath);
--- 225,234 ----
  	portbuf[0] = '\0';
  	if (request->port != urlDefaultPort(request->protocol))
  	    sprintf(portbuf, ":%d", request->port);
! 	sprintf(buf, "%s://%s%s%s%s%s",
  	    ProtocolStr[request->protocol],
+ 	    request->login,
+ 	    *request->login?"@":"",
  	    request->host,
  	    portbuf,
  	    request->urlpath);
diff -N -c -r -X exclude_files squid-1.0.beta5/src/url.h squid-1.0.beta5.henrik/src/url.h
*** squid-1.0.beta5/src/url.h	Fri Apr 19 18:46:58 1996
--- squid-1.0.beta5.henrik/src/url.h	Sun Apr 28 19:21:05 1996
***************
*** 30,35 ****
--- 30,36 ----
  typedef struct _request {
      method_t method;
      protocol_t protocol;
+     char login[MAX_URL + 1];
      char host[SQUIDHOSTNAMELEN + 1];
      int port;
      char urlpath[MAX_URL + 1];
